dnl $Id: config.m4,v 1.1 2004/12/13 04:56:31 wez Exp $
dnl vim:se ts=2 sw=2 et:
dnl config.m4 for Event Scheduler extension

PHP_ARG_ENABLE(event, whether to enable event scheduling support,
[  --enable-event           Enable event support])

if test "$PHP_EVENT" != "no"; then
  AC_CHECK_HEADERS(sys/epoll.h sys/tree.h sys/queue.h sys/event.h sys/ioctl.h sys/devpoll.h)
  AC_CHECK_FUNCS(epoll_ctl, [
    AC_DEFINE(HAVE_EPOLL,1,[have epoll])
  ])

  AC_CHECK_FUNCS(sigaction, [
  	AC_DEFINE(HAVE_SIGACTION, 1, [have sigaction()])
  ])
  PHP_CHECK_FUNC(socketpair, socket)
  AC_CHECK_FUNCS(pipe)

  AC_CHECK_FUNCS(kqueue, [
    AC_MSG_CHECKING(for working kqueue)
    AC_TRY_RUN([
#include <sys/types.h>
#include <sys/time.h>
#include <sys/event.h>
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>

int main(int argc, char **argv) {
  int kq;
  int n;
  int fd[2];
  struct kevent ev;
  struct timespec ts;
  char buf[8192];

  if (pipe(fd) == -1) exit(1);
  if (fcntl(fd[1], F_SETFL, O_NONBLOCK) == -1) exit(1);
  while ((n = write(fd[1], buf, sizeof(buf))) == sizeof(buf))
    ;
  if ((kq = kqueue()) == -1) exit(1);
  ev.ident = fd[1];
  ev.filter = EVFILT_WRITE;
  ev.flags = EV_ADD | EV_ENABLE;
  n = kevent(kq, &ev, 1, NULL, 0, NULL);
  if (n == -1) exit(1);
  read(fd[0], buf, sizeof(buf));
  ts.tv_sec = 0;
  ts.tv_nsec = 0;
  n = kevent(kq, NULL, 0, &ev, 1, &ts);
  if (n == -1 || n == 0) exit(1);
  exit(0);
}
    ],[
      AC_MSG_RESULT(yes)
      AC_DEFINE(HAVE_WORKING_KQUEUE, 1, [have working kqueue (works on pipes)])
    ],[
      AC_MSG_RESULT(no)
    ],[
      AC_MSG_RESULT(no)
    ])
  ])

  PHP_SUBST(EVENT_SHARED_LIBADD)
  PHP_NEW_EXTENSION(event, event.c poll.c epoll.c select.c, $ext_shared)
fi
